/*!
 * \file      UpperTesterGnFactory.hh
 * \brief     Header file for ITS DENM Upper Tester protocol layer factory.
 * \author    ETSI STF525
 * \copyright ETSI Copyright Notification
 *            No part may be reproduced except as authorized by written permission.
 *            The copyright and the foregoing restriction extend to reproduction in all media.
 *            All rights reserved.
 * \version   0.1
 */
#pragma once

#include "LayerStackBuilder.hh"

#include "UpperTesterGnLayer.hh"

class UpperTesterGnFactory : public LayerFactory {
  static UpperTesterGnFactory _f;
public:
  UpperTesterGnFactory() {
    // Register factory
    loggers::get_instance().log(">>> UpperTesterGnFactory::UpperTesterGnFactory");
    LayerStackBuilder::RegisterLayerFactory("UT_GN", this);
  };
  inline virtual Layer * createLayer(const std::string& p_type, const std::string& p_param){
    return new UpperTesterGnLayer(p_type, p_param);
  };
}; // End of class UpperTesterGnFactory
